<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="A lower level API for packed multiple substring search, principally for a small number of patterns."><meta name="keywords" content="rust, rustlang, rust-lang, packed"><title>aho_corasick::packed - Rust</title><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Regular.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Medium.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Bold.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Semibold.ttf.woff2"><link rel="stylesheet" type="text/css" href="../../normalize.css"><link rel="stylesheet" type="text/css" href="../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../ayu.css" disabled><link rel="stylesheet" type="text/css" href="../../dark.css" disabled><link rel="stylesheet" type="text/css" href="../../light.css" id="themeStyle"><script id="default-settings" ></script><script src="../../storage.js"></script><script defer src="../../main.js"></script><noscript><link rel="stylesheet" href="../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../favicon.svg"></head><body class="rustdoc mod"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="mobile-topbar"><button class="sidebar-menu-toggle">&#9776;</button><a class="sidebar-logo" href="../../aho_corasick/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a><h2 class="location"></h2>
    </nav>
    <nav class="sidebar"><a class="sidebar-logo" href="../../aho_corasick/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a><h2 class="location"><a href="#">Module packed</a></h2><div class="sidebar-elems"><section><div class="block"><ul><li><a href="#structs">Structs</a></li><li><a href="#enums">Enums</a></li></ul></div></section></div></nav><main><div class="width-limiter"><div class="sub-container"><a class="sub-logo-container" href="../../aho_corasick/index.html"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></a><nav class="sub"><form class="search-form"><div class="search-container"><span></span><input class="search-input" name="search" autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"><div id="help-button" title="help" tabindex="-1"><button type="button">?</button></div><div id="settings-menu" tabindex="-1">
                                <a href="../../settings.html" title="settings"><img width="22" height="22" alt="Change settings" src="../../wheel.svg"></a></div>
                        </div></form></nav></div><section id="main-content" class="content"><div class="main-heading">
    <h1 class="fqn"><span class="in-band">Module <a href="../index.html">aho_corasick</a>::<wbr><a class="mod" href="#">packed</a><button id="copy-path" onclick="copy_path(this)" title="Copy item path to clipboard"><img src="../../clipboard.svg" width="19" height="18" alt="Copy item path"></button></span></h1><span class="out-of-band"><a class="srclink" href="../../src/aho_corasick/packed/mod.rs.html#1-117">source</a> · <a id="toggle-all-docs" href="javascript:void(0)" title="collapse all docs">[<span class="inner">&#x2212;</span>]</a></span></div><details class="rustdoc-toggle top-doc" open><summary class="hideme"><span>Expand description</span></summary><div class="docblock"><p>A lower level API for packed multiple substring search, principally for a small
number of patterns.</p>
<p>This sub-module provides vectorized routines for quickly finding matches of a
small number of patterns. In general, users of this crate shouldn’t need to
interface with this module directory, as the primary
<a href="../struct.AhoCorasick.html"><code>AhoCorasick</code></a>
searcher will use these routines automatically as a prefilter when applicable.
However, in some cases, callers may want to bypass the Aho-Corasick machinery
entirely and use this vectorized searcher directly.</p>
<h2 id="overview"><a href="#overview">Overview</a></h2>
<p>The primary types in this sub-module are:</p>
<ul>
<li><a href="struct.Searcher.html"><code>Searcher</code></a> executes the actual search algorithm to
report matches in a haystack.</li>
<li><a href="struct.Builder.html"><code>Builder</code></a> accumulates patterns incrementally and can
construct a <code>Searcher</code>.</li>
<li><a href="struct.Config.html"><code>Config</code></a> permits tuning the searcher, and itself will
produce a <code>Builder</code> (which can then be used to build a <code>Searcher</code>).
Currently, the only tuneable knob are the match semantics, but this may be
expanded in the future.</li>
</ul>
<h2 id="examples"><a href="#examples">Examples</a></h2>
<p>This example shows how to create a searcher from an iterator of patterns.
By default, leftmost-first match semantics are used. (See the top-level
<a href="../enum.MatchKind.html"><code>MatchKind</code></a> type for more details about match
semantics, which apply similarly to packed substring search.)</p>

<div class="example-wrap"><pre class="rust rust-example-rendered"><code><span class="kw">use</span> <span class="ident">aho_corasick::packed</span>::{<span class="ident">MatchKind</span>, <span class="ident">Searcher</span>};

<span class="kw">let</span> <span class="ident">searcher</span> <span class="op">=</span> <span class="ident">Searcher::new</span>([<span class="string">&quot;foobar&quot;</span>, <span class="string">&quot;foo&quot;</span>].<span class="ident">iter</span>().<span class="ident">cloned</span>())<span class="question-mark">?</span>;
<span class="kw">let</span> <span class="ident">matches</span>: <span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">usize</span><span class="op">&gt;</span> <span class="op">=</span> <span class="ident">searcher</span>
    .<span class="ident">find_iter</span>(<span class="string">&quot;foobar&quot;</span>)
    .<span class="ident">map</span>(<span class="op">|</span><span class="ident">mat</span><span class="op">|</span> <span class="ident">mat</span>.<span class="ident">pattern</span>())
    .<span class="ident">collect</span>();
<span class="macro">assert_eq!</span>(<span class="macro">vec!</span>[<span class="number">0</span>], <span class="ident">matches</span>);</code></pre></div>
<p>This example shows how to use <a href="struct.Config.html"><code>Config</code></a> to change the
match semantics to leftmost-longest:</p>

<div class="example-wrap"><pre class="rust rust-example-rendered"><code><span class="kw">use</span> <span class="ident">aho_corasick::packed</span>::{<span class="ident">Config</span>, <span class="ident">MatchKind</span>};

<span class="kw">let</span> <span class="ident">searcher</span> <span class="op">=</span> <span class="ident">Config::new</span>()
    .<span class="ident">match_kind</span>(<span class="ident">MatchKind::LeftmostLongest</span>)
    .<span class="ident">builder</span>()
    .<span class="ident">add</span>(<span class="string">&quot;foo&quot;</span>)
    .<span class="ident">add</span>(<span class="string">&quot;foobar&quot;</span>)
    .<span class="ident">build</span>()<span class="question-mark">?</span>;
<span class="kw">let</span> <span class="ident">matches</span>: <span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">usize</span><span class="op">&gt;</span> <span class="op">=</span> <span class="ident">searcher</span>
    .<span class="ident">find_iter</span>(<span class="string">&quot;foobar&quot;</span>)
    .<span class="ident">map</span>(<span class="op">|</span><span class="ident">mat</span><span class="op">|</span> <span class="ident">mat</span>.<span class="ident">pattern</span>())
    .<span class="ident">collect</span>();
<span class="macro">assert_eq!</span>(<span class="macro">vec!</span>[<span class="number">1</span>], <span class="ident">matches</span>);</code></pre></div>
<h2 id="packed-substring-searching"><a href="#packed-substring-searching">Packed substring searching</a></h2>
<p>Packed substring searching refers to the use of SIMD (Single Instruction,
Multiple Data) to accelerate the detection of matches in a haystack. Unlike
conventional algorithms, such as Aho-Corasick, SIMD algorithms for substring
search tend to do better with a small number of patterns, where as Aho-Corasick
generally maintains reasonably consistent performance regardless of the number
of patterns you give it. Because of this, the vectorized searcher in this
sub-module cannot be used as a general purpose searcher, since building the
searcher may fail. However, in exchange, when searching for a small number of
patterns, searching can be quite a bit faster than Aho-Corasick (sometimes by
an order of magnitude).</p>
<p>The key take away here is that constructing a searcher from a list of patterns
is a fallible operation. While the precise conditions under which building a
searcher can fail is specifically an implementation detail, here are some
common reasons:</p>
<ul>
<li>Too many patterns were given. Typically, the limit is on the order of 100 or
so, but this limit may fluctuate based on available CPU features.</li>
<li>The available packed algorithms require CPU features that aren’t available.
For example, currently, this crate only provides packed algorithms for
<code>x86_64</code>. Therefore, constructing a packed searcher on any other target
(e.g., ARM) will always fail.</li>
<li>Zero patterns were given, or one of the patterns given was empty. Packed
searchers require at least one pattern and that all patterns are non-empty.</li>
<li>Something else about the nature of the patterns (typically based on
heuristics) suggests that a packed searcher would perform very poorly, so
no searcher is built.</li>
</ul>
</div></details><h2 id="structs" class="small-section-header"><a href="#structs">Structs</a></h2>
<div class="item-table"><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.Builder.html" title="aho_corasick::packed::Builder struct">Builder</a></div><div class="item-right docblock-short"><p>A builder for constructing a packed searcher from a collection of patterns.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.Config.html" title="aho_corasick::packed::Config struct">Config</a></div><div class="item-right docblock-short"><p>The configuration for a packed multiple pattern searcher.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.FindIter.html" title="aho_corasick::packed::FindIter struct">FindIter</a></div><div class="item-right docblock-short"><p>An iterator over non-overlapping matches from a packed searcher.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.Searcher.html" title="aho_corasick::packed::Searcher struct">Searcher</a></div><div class="item-right docblock-short"><p>A packed searcher for quickly finding occurrences of multiple patterns.</p>
</div></div></div><h2 id="enums" class="small-section-header"><a href="#enums">Enums</a></h2>
<div class="item-table"><div class="item-row"><div class="item-left module-item"><a class="enum" href="enum.MatchKind.html" title="aho_corasick::packed::MatchKind enum">MatchKind</a></div><div class="item-right docblock-short"><p>A knob for controlling the match semantics of a packed multiple string
searcher.</p>
</div></div></div></section></div></main><div id="rustdoc-vars" data-root-path="../../" data-current-crate="aho_corasick" data-themes="ayu,dark,light" data-resource-suffix="" data-rustdoc-version="1.64.0-dev" ></div>
</body></html>